Index: /LMDZ5/trunk/libf/phylmd/rrtm/readaerosolstrato_rrtm.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/rrtm/readaerosolstrato_rrtm.F90	(revision 2145)
+++ /LMDZ5/trunk/libf/phylmd/rrtm/readaerosolstrato_rrtm.F90	(revision 2146)
@@ -16,7 +16,9 @@
     USE aero_mod
     USE dimphy
+    USE YOERAD   , ONLY : NLW
 
     implicit none
 
+    include "YOMCST.h"
     include "dimensions.h"
 
@@ -33,5 +35,5 @@
     real, pointer:: time(:)
     real, pointer:: lev(:)
-    integer k, band, wave
+    integer k, band, wave, i
     integer, save :: mth_pre
 
@@ -45,4 +47,6 @@
     real, allocatable:: tauaerstrat_mois_glo_bands(:,:,:)
 
+    real, allocatable:: sum_tau_aer_strat(:)
+
 ! For NetCDF:
     integer ncid_in  ! IDs for input files
@@ -50,16 +54,30 @@
 
 ! Stratospheric aerosols optical properties
-! alpha_strat over the 2 bands is normalised by the 550 nm extinction coefficient
-! alpha_strat_wave is *not* normalised by the 550 nm extinction coefficient
-    real, dimension(nbands_rrtm) :: alpha_strat, piz_strat, cg_strat
-    data alpha_strat/0.938538969, 0.990073204, 0.992904723, 0.829215884, 0.439313501, 0.156857833/
-    data cg_strat   /0.699142992, 0.716326416, 0.735462785, 0.736726701, 0.712068975, 0.575097859/
-    data piz_strat  /1.000000000, 1.000000000, 1.000000000, 1.000000000, 0.997781098, 0.452584684/
-    real, dimension(nwave) :: alpha_strat_wave
-    data alpha_strat_wave/3.36780953,3.34667683,3.20444202,3.0293026,2.82108808/
-
+! alpha_sw_strat over the 6 bands is normalised by the 550 nm extinction coefficient
+    real, dimension(nbands_sw_rrtm) :: alpha_sw_strat, piz_sw_strat, cg_sw_strat
+    data alpha_sw_strat/0.8545564, 0.8451642, 0.9821724, 0.8145110, 0.3073565, 7.7966176E-02/
+    data cg_sw_strat   /0.6997170, 0.6810035, 0.7403592, 0.7562674, 0.6676504, 0.3478689/
+    data piz_sw_strat  /0.9999998, 0.9999998, 1.000000000, 0.9999958, 0.9977155, 0.4510679/
+!
+!--diagnostics AOD in the SW
+! alpha_sw_strat_wave is *not* normalised by the 550 nm extinction coefficient
+    real, dimension(nwave) :: alpha_sw_strat_wave
+    data alpha_sw_strat_wave/3.708007,4.125824,4.136584,3.887478,3.507738/
+!
+!--diagnostics AOD in the LW at 10 um 
+    real :: alpha_lw_strat_wave
+    data alpha_lw_strat_wave/0.2746812/
+!
+    real, dimension(nbands_lw_rrtm) :: alpha_lw_abs_rrtm
+    data alpha_lw_abs_rrtm/   8.8340312E-02, 6.9856711E-02, 6.2652975E-02, 5.7188231E-02, &
+                              6.3157059E-02, 5.5072524E-02, 5.0571125E-02, 0.1349073, &    
+                              0.1381676, 9.6506312E-02, 5.1312990E-02, 2.4256418E-02, &
+                              2.7191756E-02, 3.3862915E-02, 1.6132960E-02, 1.4275438E-02/ ! calculated with Mie_SW_LW_RRTM_V2.4 (bimodal, corrected)
+                                                                                          ! for r_0=/0.13E-6, 0.41E-6/ m, sigma_g=/1.26, 1.30/
+                                                                                          ! order: increasing wavelength!
 !--------------------------------------------------------
 
     IF (.not.ALLOCATED(tau_aer_strat)) ALLOCATE(tau_aer_strat(klon,klev))
+    IF (.not.ALLOCATED(sum_tau_aer_strat)) ALLOCATE(sum_tau_aer_strat(klon))
 
     IF (is_mpi_root) THEN
@@ -67,6 +85,6 @@
     IF (debut.OR.mth_cur.NE.mth_pre) THEN
 
-    IF (nbands_rrtm.NE.6) THEN 
-        print *,'nbands_rrtm doit etre egal a 6 dans readaerosolstrat_rrtm'
+    IF (nbands_sw_rrtm.NE.6) THEN 
+        print *,'nbands_sw_rrtm doit etre egal a 6 dans readaerosolstrat_rrtm'
         STOP
     ENDIF
@@ -112,5 +130,5 @@
     ALLOCATE(tauaerstrat_mois(n_lon, n_lat, n_lev))
     ALLOCATE(tauaerstrat_mois_glo(klon_glo, n_lev))
-    ALLOCATE(tauaerstrat_mois_glo_bands(klon_glo, n_lev,nbands_rrtm))
+    ALLOCATE(tauaerstrat_mois_glo_bands(klon_glo, n_lev,nbands_sw_rrtm))
 
 !--reading stratospheric AOD at 550 nm
@@ -143,31 +161,48 @@
     ENDIF !--is_mpi_root
 
-!--total vertical aod at the 5 wavelengths
+!--total vertical aod at the 5 SW wavelengths
     DO wave=1, nwave
     DO k=1, klev
-    tausum_aero(:,wave,id_strat)=tausum_aero(:,wave,id_strat)+tau_aer_strat(:,k)*alpha_strat_wave(wave)/alpha_strat_wave(2)
+    tausum_aero(:,wave,id_STRAT_phy)=tausum_aero(:,wave,id_STRAT_phy)+tau_aer_strat(:,k)*alpha_sw_strat_wave(wave)/alpha_sw_strat_wave(2)
     ENDDO
     ENDDO
 
 !--weighted average for cg, piz and tau, adding strat aerosols on top of tropospheric ones
-    DO band=1, nbands_rrtm
-!--anthropogenic aerosols bands 1 to nbands_rrtm 
-    cg_aero_rrtm(:,:,2,band)  = ( cg_aero_rrtm(:,:,2,band)*piz_aero_rrtm(:,:,2,band)*tau_aero_rrtm(:,:,2,band) + &
-                                  cg_strat(band)*piz_strat(band)*alpha_strat(band)*tau_aer_strat(:,:) ) /        &
-                             MAX( piz_aero_rrtm(:,:,2,band)*tau_aero_rrtm(:,:,2,band) +                          &
-                                  piz_strat(band)*alpha_strat(band)*tau_aer_strat(:,:), 1.e-15 )
-    piz_aero_rrtm(:,:,2,band)  = ( piz_aero_rrtm(:,:,2,band)*tau_aero_rrtm(:,:,2,band) +                         &
-                              piz_strat(band)*alpha_strat(band)*tau_aer_strat(:,:) ) /                           &
-                              MAX( tau_aero_rrtm(:,:,2,band) + alpha_strat(band)*tau_aer_strat(:,:), 1.e-15 )
-    tau_aero_rrtm(:,:,2,band)  = tau_aero_rrtm(:,:,2,band) + alpha_strat(band)*tau_aer_strat(:,:)
-!--natural aerosols bands 1 to nbands_rrtm
-    cg_aero_rrtm(:,:,1,band)  = ( cg_aero_rrtm(:,:,1,band)*piz_aero_rrtm(:,:,1,band)*tau_aero_rrtm(:,:,1,band) + &
-                             cg_strat(band)*piz_strat(band)*alpha_strat(band)*tau_aer_strat(:,:) ) /             &
-                             MAX( piz_aero_rrtm(:,:,1,band)*tau_aero_rrtm(:,:,1,band) +                          &
-                                  piz_strat(band)*alpha_strat(band)*tau_aer_strat(:,:), 1.e-15 )
-    piz_aero_rrtm(:,:,1,band)  = ( piz_aero_rrtm(:,:,1,band)*tau_aero_rrtm(:,:,1,band) +                         & 
-                              piz_strat(band)*alpha_strat(band)*tau_aer_strat(:,:) ) /                           &
-                              MAX( tau_aero_rrtm(:,:,1,band) + alpha_strat(band)*tau_aer_strat(:,:),1.e-15 )
-    tau_aero_rrtm(:,:,1,band)  = tau_aero_rrtm(:,:,1,band) + alpha_strat(band)*tau_aer_strat(:,:)
+    DO band=1, nbands_sw_rrtm
+!--anthropogenic aerosols bands 1 to nbands_sw_rrtm 
+    cg_aero_sw_rrtm(:,:,2,band)  = ( cg_aero_sw_rrtm(:,:,2,band)*piz_aero_sw_rrtm(:,:,2,band)*tau_aero_sw_rrtm(:,:,2,band) + &
+                                  cg_sw_strat(band)*piz_sw_strat(band)*alpha_sw_strat(band)*tau_aer_strat(:,:) ) /           &
+                             MAX( piz_aero_sw_rrtm(:,:,2,band)*tau_aero_sw_rrtm(:,:,2,band) +                                &
+                                  piz_sw_strat(band)*alpha_sw_strat(band)*tau_aer_strat(:,:), 1.e-15 )
+    piz_aero_sw_rrtm(:,:,2,band)  = ( piz_aero_sw_rrtm(:,:,2,band)*tau_aero_sw_rrtm(:,:,2,band) +                            &
+                              piz_sw_strat(band)*alpha_sw_strat(band)*tau_aer_strat(:,:) ) /                                 &
+                              MAX( tau_aero_sw_rrtm(:,:,2,band) + alpha_sw_strat(band)*tau_aer_strat(:,:), 1.e-15 )
+    tau_aero_sw_rrtm(:,:,2,band)  = tau_aero_sw_rrtm(:,:,2,band) + alpha_sw_strat(band)*tau_aer_strat(:,:)
+!--natural aerosols bands 1 to nbands_sw_rrtm
+    cg_aero_sw_rrtm(:,:,1,band)  = ( cg_aero_sw_rrtm(:,:,1,band)*piz_aero_sw_rrtm(:,:,1,band)*tau_aero_sw_rrtm(:,:,1,band) + &
+                             cg_sw_strat(band)*piz_sw_strat(band)*alpha_sw_strat(band)*tau_aer_strat(:,:) ) /                &
+                             MAX( piz_aero_sw_rrtm(:,:,1,band)*tau_aero_sw_rrtm(:,:,1,band) +                                &
+                                  piz_sw_strat(band)*alpha_sw_strat(band)*tau_aer_strat(:,:), 1.e-15 )
+    piz_aero_sw_rrtm(:,:,1,band)  = ( piz_aero_sw_rrtm(:,:,1,band)*tau_aero_sw_rrtm(:,:,1,band) +                            &
+                              piz_sw_strat(band)*alpha_sw_strat(band)*tau_aer_strat(:,:) ) /                                 &
+                              MAX( tau_aero_sw_rrtm(:,:,1,band) + alpha_sw_strat(band)*tau_aer_strat(:,:),1.e-15 )
+    tau_aero_sw_rrtm(:,:,1,band)  = tau_aero_sw_rrtm(:,:,1,band) + alpha_sw_strat(band)*tau_aer_strat(:,:)
+!--no stratospheric aerosol in index 1 for these tests
+!    cg_aero_sw_rrtm(:,:,1,band)  =  cg_aero_sw_rrtm(:,:,1,band)
+!    piz_aero_sw_rrtm(:,:,1,band)  = piz_aero_sw_rrtm(:,:,1,band)
+!    tau_aero_sw_rrtm(:,:,1,band)  = tau_aero_sw_rrtm(:,:,1,band)
+    ENDDO
+
+!--stratospheric AOD in LW
+    IF (nbands_lw_rrtm .NE. NLW) then
+      print*, 'different values for NLW (=',NLW,') and nbands_lw_rrtm (=', nbands_lw_rrtm, ')'
+      STOP
+    ENDIF 
+
+    DO band=1, nbands_lw_rrtm
+    tau_aero_lw_rrtm(:,:,2,band)  = tau_aero_lw_rrtm(:,:,2,band) + alpha_lw_abs_rrtm(band)*tau_aer_strat(:,:)
+    tau_aero_lw_rrtm(:,:,1,band)  = tau_aero_lw_rrtm(:,:,1,band) + alpha_lw_abs_rrtm(band)*tau_aer_strat(:,:) 
+!--no stratospheric aerosols in index 1 for these tests
+!    tau_aero_lw_rrtm(:,:,1,band)  = tau_aero_lw_rrtm(:,:,1,band) 
     ENDDO
 
Index: /LMDZ5/trunk/libf/phylmd/rrtm/recmwf_aero.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/rrtm/recmwf_aero.F90	(revision 2145)
+++ /LMDZ5/trunk/libf/phylmd/rrtm/recmwf_aero.F90	(revision 2146)
@@ -20,4 +20,7 @@
  & PPIZA_NAT,PCGA_NAT,PTAU_NAT, & 
 !--fin OB 
+!--C.Kleinschmitt
+ & PTAU_LW_TOT, PTAU_LW_NAT, & 
+!--end
  & PFLUX,PFLUC,&
  & PFSDN ,PFSUP , PFSCDN , PFSCUP,&
@@ -27,4 +30,9 @@
  & PTOPSWAIAERO,PSOLSWAIAERO,&
  & PTOPSWCFAERO,PSOLSWCFAERO,&
+!--LW diagnostics CK
+ & PTOPLWADAERO,PSOLLWADAERO,&
+ & PTOPLWAD0AERO,PSOLLWAD0AERO,&
+ & PTOPLWAIAERO,PSOLLWAIAERO,&
+!..end
  & ok_ade, ok_aie, flag_aerosol,flag_aerosol_strat)
 !--fin
@@ -79,4 +87,6 @@
 ! PCGA_NAT   : (KPROMA,KLEV,NSW); Assymetry factor for natural aerosol
 ! PTAU_NAT: (KPROMA,KLEV,NSW)   ; Optical depth of natural aerosol
+! PTAU_LW_TOT  (KPROMA,KLEV,NLW); LW Optical depth of total aerosols  
+! PTAU_LW_NAT  (KPROMA,KLEV,NLW); LW Optical depth of natural aerosols 
 !--fin OB
 
@@ -136,4 +146,5 @@
 USE YOMCST   , ONLY :         RMD      ,RMO3
 USE YOMPHY3  , ONLY : RII0
+USE YOERAD   , ONLY : NLW, NAER, RCCNLND  ,RCCNSEA  
 USE YOERAD   , ONLY : NAER, RCCNLND  ,RCCNSEA  
 USE YOERDU   , ONLY : REPSCQ
@@ -150,4 +161,5 @@
 IMPLICIT NONE
 INCLUDE "clesphys.h"
+
 
 INTEGER(KIND=JPIM),INTENT(IN)    :: KPROMA 
@@ -186,4 +198,9 @@
 REAL(KIND=JPRB)                  :: PTAU_ZERO(KPROMA,KLEV,NSW)
 !--fin
+!--C.Kleinschmitt
+REAL(KIND=JPRB)                  :: PTAU_LW_ZERO(KPROMA,KLEV,NLW)
+REAL(KIND=JPRB)   ,INTENT(IN)    :: PTAU_LW_TOT(KPROMA,KLEV,NLW)
+REAL(KIND=JPRB)   ,INTENT(IN)    :: PTAU_LW_NAT(KPROMA,KLEV,NLW)
+!--end
 REAL(KIND=JPRB)   ,INTENT(IN)    :: PREF_LIQ(KPROMA,KLEV)
 REAL(KIND=JPRB)   ,INTENT(IN)    :: PREF_ICE(KPROMA,KLEV)
@@ -199,4 +216,9 @@
 REAL(KIND=JPRB)   ,INTENT(OUT)   :: PTOPSWCFAERO(KPROMA,3), PSOLSWCFAERO(KPROMA,3) !--do we keep this ?
 !--fin
+!--CK
+REAL(KIND=JPRB)   ,INTENT(out)   :: PTOPLWADAERO(KPROMA), PSOLLWADAERO(KPROMA)       ! LW Aerosol direct forcing at TOA + surface
+REAL(KIND=JPRB)   ,INTENT(OUT)   :: PTOPLWAD0AERO(KPROMA), PSOLLWAD0AERO(KPROMA)     ! LW Aerosol direct forcing at TOA + surface
+REAL(KIND=JPRB)   ,INTENT(OUT)   :: PTOPLWAIAERO(KPROMA), PSOLLWAIAERO(KPROMA)       ! LW Aer. indirect forcing at TOA + surface
+!--end
 REAL(KIND=JPRB)   ,INTENT(OUT)   :: PEMTD(KPROMA,KLEV+1) 
 REAL(KIND=JPRB)   ,INTENT(OUT)   :: PEMTU(KPROMA,KLEV+1) 
@@ -295,4 +317,9 @@
 REAL(KIND=JPRB) ::  ZFSUP0_AERO(KPROMA,KLEV+1,5)
 REAL(KIND=JPRB) ::  ZFSDN0_AERO(KPROMA,KLEV+1,5)
+!--LW (CK):
+REAL(KIND=JPRB) ::  LWUP_AERO(KPROMA,KLEV+1,5)
+REAL(KIND=JPRB) ::  LWDN_AERO(KPROMA,KLEV+1,5)
+REAL(KIND=JPRB) ::  LWUP0_AERO(KPROMA,KLEV+1,5)
+REAL(KIND=JPRB) ::  LWDN0_AERO(KPROMA,KLEV+1,5)
 
 #include "radlsw.intfb.h"
@@ -313,7 +340,14 @@
 ZFSDN0_AERO(:,:,:)=0.
 
+LWUP_AERO (:,:,:)=0.
+LWDN_AERO (:,:,:)=0.
+LWUP0_AERO(:,:,:)=0.
+LWDN0_AERO(:,:,:)=0.
+
 PTAU_ZERO(:,:,:) =1.e-15
 PPIZA_ZERO(:,:,:)=1.0
 PCGA_ZERO(:,:,:) =0.0
+
+PTAU_LW_ZERO(:,:,:) =1.e-15
 
 
@@ -431,5 +465,5 @@
  & ZFRSOD, ZSUDU  , ZUVDF   , ZPARF   , ZPARCF, ZTINCF, PSFSWDIR,&
  & PSFSWDIF,PFSDNN, PFSDNV  ,&  
- & LRDUST,PPIZA_NAT,PCGA_NAT,PTAU_NAT,PFLUX,PFLUC,&
+ & LRDUST,PPIZA_NAT,PCGA_NAT,PTAU_NAT,PTAU_LW_NAT,PFLUX,PFLUC,&
  & PFSDN , PFSUP  , PFSCDN  , PFSCUP )
 
@@ -440,4 +474,10 @@
 ZFSUP_AERO(:,:,1) =  PFSUP(:,:)
 ZFSDN_AERO(:,:,1) =  PFSDN(:,:)
+
+LWUP0_AERO(:,:,1) = PFLUC(:,1,:)
+LWDN0_AERO(:,:,1) = PFLUC(:,2,:)
+
+LWUP_AERO(:,:,1) = PFLUX(:,1,:)
+LWDN_AERO(:,:,1) = PFLUX(:,2,:)
 
 ENDIF 
@@ -463,5 +503,5 @@
  & ZFRSOD, ZSUDU  , ZUVDF   , ZPARF   , ZPARCF, ZTINCF, PSFSWDIR,&
  & PSFSWDIF,PFSDNN, PFSDNV  ,&  
- & LRDUST,PPIZA_NAT,PCGA_NAT,PTAU_NAT,PFLUX,PFLUC,&
+ & LRDUST,PPIZA_NAT,PCGA_NAT,PTAU_NAT,PTAU_LW_NAT,PFLUX,PFLUC,&
  & PFSDN , PFSUP  , PFSCDN  , PFSCUP )
 
@@ -472,4 +512,10 @@
 ZFSUP_AERO(:,:,2) =  PFSUP(:,:)
 ZFSDN_AERO(:,:,2) =  PFSDN(:,:)
+
+LWUP0_AERO(:,:,2) = PFLUC(:,1,:)
+LWDN0_AERO(:,:,2) = PFLUC(:,2,:)
+
+LWUP_AERO(:,:,2) = PFLUX(:,1,:)
+LWDN_AERO(:,:,2) = PFLUX(:,2,:)
 
 ENDIF ! ok_aie      
@@ -495,5 +541,5 @@
  & ZFRSOD, ZSUDU  , ZUVDF   , ZPARF   , ZPARCF, ZTINCF, PSFSWDIR,&
  & PSFSWDIF,PFSDNN, PFSDNV  ,&  
- & LRDUST,PPIZA_TOT,PCGA_TOT,PTAU_TOT,PFLUX,PFLUC,&
+ & LRDUST,PPIZA_TOT,PCGA_TOT,PTAU_TOT,PTAU_LW_TOT,PFLUX,PFLUC,&
  & PFSDN , PFSUP  , PFSCDN  , PFSCUP )
 
@@ -504,4 +550,10 @@
 ZFSUP_AERO(:,:,3) =  PFSUP(:,:)
 ZFSDN_AERO(:,:,3) =  PFSDN(:,:)
+
+LWUP0_AERO(:,:,3) = PFLUC(:,1,:)
+LWDN0_AERO(:,:,3) = PFLUC(:,2,:)
+
+LWUP_AERO(:,:,3) = PFLUX(:,1,:)
+LWDN_AERO(:,:,3) = PFLUX(:,2,:)
 
 ENDIF !-end ok_ade
@@ -527,5 +579,5 @@
  & ZFRSOD, ZSUDU  , ZUVDF   , ZPARF   , ZPARCF, ZTINCF, PSFSWDIR,&
  & PSFSWDIF,PFSDNN, PFSDNV  ,&  
- & LRDUST,PPIZA_TOT,PCGA_TOT,PTAU_TOT,PFLUX,PFLUC,&
+ & LRDUST,PPIZA_TOT,PCGA_TOT,PTAU_TOT,PTAU_LW_TOT,PFLUX,PFLUC,&
  & PFSDN , PFSUP  , PFSCDN  , PFSCUP )
 
@@ -536,4 +588,10 @@
 ZFSUP_AERO(:,:,4) =  PFSUP(:,:)
 ZFSDN_AERO(:,:,4) =  PFSDN(:,:)
+
+LWUP0_AERO(:,:,4) = PFLUC(:,1,:)
+LWDN0_AERO(:,:,4) = PFLUC(:,2,:)
+
+LWUP_AERO(:,:,4) = PFLUX(:,1,:)
+LWDN_AERO(:,:,4) = PFLUX(:,2,:)
 
 ENDIF ! ok_ade .and. ok_aie
@@ -563,5 +621,5 @@
  & ZFRSOD, ZSUDU  , ZUVDF   , ZPARF   , ZPARCF, ZTINCF, PSFSWDIR,&
  & PSFSWDIF,PFSDNN, PFSDNV  ,&  
- & LRDUST,PPIZA_ZERO,PCGA_ZERO,PTAU_ZERO,PFLUX,PFLUC,&
+ & LRDUST,PPIZA_ZERO,PCGA_ZERO,PTAU_ZERO, PTAU_LW_ZERO,PFLUX,PFLUC,&
  & PFSDN , PFSUP  , PFSCDN  , PFSCUP )
 
@@ -572,4 +630,10 @@
 ZFSUP_AERO(:,:,5) =  PFSUP(:,:)
 ZFSDN_AERO(:,:,5) =  PFSDN(:,:)
+
+LWUP0_AERO(:,:,5) = PFLUC(:,1,:)
+LWDN0_AERO(:,:,5) = PFLUC(:,2,:)
+
+LWUP_AERO(:,:,5) = PFLUX(:,1,:)
+LWDN_AERO(:,:,5) = PFLUX(:,2,:)
 
 ENDIF ! .not. AEROSOLFEEDBACK_ACTIVE
@@ -643,4 +707,9 @@
     PFSCUP(:,:) =   ZFSUP0_AERO(:,:,4)
     PFSCDN(:,:) =   ZFSDN0_AERO(:,:,4)
+
+    PFLUX(:,1,:) =  LWUP_AERO(:,:,4)
+    PFLUX(:,2,:) =  LWDN_AERO(:,:,4)
+    PFLUC(:,1,:) =  LWUP0_AERO(:,:,4)
+    PFLUC(:,2,:) =  LWDN0_AERO(:,:,4)    
   ENDIF
 
@@ -650,4 +719,9 @@
     PFSCUP(:,:) =   ZFSUP0_AERO(:,:,3)
     PFSCDN(:,:) =   ZFSDN0_AERO(:,:,3)
+
+    PFLUX(:,1,:) =  LWUP_AERO(:,:,3)
+    PFLUX(:,2,:) =  LWDN_AERO(:,:,3)
+    PFLUC(:,1,:) =  LWUP0_AERO(:,:,3)
+    PFLUC(:,2,:) =  LWDN0_AERO(:,:,3) 
   ENDIF
 
@@ -657,4 +731,9 @@
     PFSCUP(:,:) =   ZFSUP0_AERO(:,:,2)
     PFSCDN(:,:) =   ZFSDN0_AERO(:,:,2)
+
+    PFLUX(:,1,:) =  LWUP_AERO(:,:,2)
+    PFLUX(:,2,:) =  LWDN_AERO(:,:,2)
+    PFLUC(:,1,:) =  LWUP0_AERO(:,:,2)
+    PFLUC(:,2,:) =  LWDN0_AERO(:,:,2) 
   ENDiF
 
@@ -664,4 +743,9 @@
     PFSCUP(:,:) =   ZFSUP0_AERO(:,:,1)
     PFSCDN(:,:) =   ZFSDN0_AERO(:,:,1)
+
+    PFLUX(:,1,:) =  LWUP_AERO(:,:,1)
+    PFLUX(:,2,:) =  LWDN_AERO(:,:,1)
+    PFLUC(:,1,:) =  LWUP0_AERO(:,:,1)
+    PFLUC(:,2,:) =  LWDN0_AERO(:,:,1) 
   ENDIF
 
@@ -677,4 +761,9 @@
     PFSCDN(:,:) =   ZFSDN0_AERO(:,:,5)
 
+    PFLUX(:,1,:) =  LWUP_AERO(:,:,5)
+    PFLUX(:,2,:) =  LWDN_AERO(:,:,5)
+    PFLUC(:,1,:) =  LWUP0_AERO(:,:,5)
+    PFLUC(:,2,:) =  LWDN0_AERO(:,:,5) 
+
 ENDIF
 
@@ -683,5 +772,5 @@
 ! requires a natural aerosol field read and used 
 ! Difference of net fluxes from double call to radiation
-! Will need to be extended to LW radiation
+! Will need to be extended to LW radiation -> done by CK (2014-05-23)
 
 IF (flag_aerosol .GT. 0 .OR. flag_aerosol_strat) THEN
@@ -709,4 +798,14 @@
      PTOPSWCFAERO(:,3) = 0.0
 
+! LW direct anthropogenic forcing
+     PSOLLWADAERO(:)  = (-LWDN_AERO(:,1,4)      -LWUP_AERO(:,1,4))      -(-LWDN_AERO(:,1,2)      -LWUP_AERO(:,1,2))
+     PTOPLWADAERO(:)  = (-LWDN_AERO(:,KLEV+1,4) -LWUP_AERO(:,KLEV+1,4)) -(-LWDN_AERO(:,KLEV+1,2) -LWUP_AERO(:,KLEV+1,2))
+     PSOLLWAD0AERO(:) = (-LWDN0_AERO(:,1,4)     -LWUP0_AERO(:,1,4))     -(-LWDN0_AERO(:,1,2)     -LWUP0_AERO(:,1,2))
+     PTOPLWAD0AERO(:) = (-LWDN0_AERO(:,KLEV+1,4)-LWUP0_AERO(:,KLEV+1,4))-(-LWDN0_AERO(:,KLEV+1,2)-LWUP0_AERO(:,KLEV+1,2))
+
+! LW indirect anthropogenic forcing
+     PSOLLWAIAERO(:) = (-LWDN_AERO(:,1,4)     -LWUP_AERO(:,1,4))     -(-LWDN_AERO(:,1,3)     -LWUP_AERO(:,1,3))
+     PTOPLWAIAERO(:) = (-LWDN_AERO(:,KLEV+1,4)-LWUP_AERO(:,KLEV+1,4))-(-LWDN_AERO(:,KLEV+1,3)-LWUP_AERO(:,KLEV+1,3))
+
 ENDIF
 
@@ -733,4 +832,14 @@
      PTOPSWCFAERO(:,3) = 0.0
 
+! LW direct anthropogenic forcing
+     PSOLLWADAERO(:)  = (-LWDN_AERO(:,1,3)      -LWUP_AERO(:,1,3))      -(-LWDN_AERO(:,1,1)      -LWUP_AERO(:,1,1))
+     PTOPLWADAERO(:)  = (-LWDN_AERO(:,KLEV+1,3) -LWUP_AERO(:,KLEV+1,3)) -(-LWDN_AERO(:,KLEV+1,1) -LWUP_AERO(:,KLEV+1,1))
+     PSOLLWAD0AERO(:) = (-LWDN0_AERO(:,1,3)     -LWUP0_AERO(:,1,3))     -(-LWDN0_AERO(:,1,1)     -LWUP0_AERO(:,1,1))
+     PTOPLWAD0AERO(:) = (-LWDN0_AERO(:,KLEV+1,3)-LWUP0_AERO(:,KLEV+1,3))-(-LWDN0_AERO(:,KLEV+1,1)-LWUP0_AERO(:,KLEV+1,1))
+
+! LW indirect anthropogenic forcing
+     PSOLLWAIAERO(:) = 0.0
+     PTOPLWAIAERO(:) = 0.0 
+
 ENDIF
 
@@ -757,4 +866,14 @@
      PTOPSWCFAERO(:,3) = 0.0
 
+! LW direct anthropogenic forcing
+     PSOLLWADAERO(:)  = 0.0
+     PTOPLWADAERO(:)  = 0.0
+     PSOLLWAD0AERO(:) = 0.0
+     PTOPLWAD0AERO(:) = 0.0
+
+! LW indirect anthropogenic forcing
+     PSOLLWAIAERO(:) = (-LWDN_AERO(:,1,2)     -LWUP_AERO(:,1,2))     -(-LWDN_AERO(:,1,1)     -LWUP_AERO(:,1,1))
+     PTOPLWAIAERO(:) = (-LWDN_AERO(:,KLEV+1,2)-LWUP_AERO(:,KLEV+1,2))-(-LWDN_AERO(:,KLEV+1,1)-LWUP_AERO(:,KLEV+1,1))
+
 ENDIF
 
@@ -781,4 +900,14 @@
      PTOPSWCFAERO(:,3) = 0.0
 
+! LW direct anthropogenic forcing
+     PSOLLWADAERO(:)  = 0.0
+     PTOPLWADAERO(:)  = 0.0
+     PSOLLWAD0AERO(:) = 0.0
+     PTOPLWAD0AERO(:) = 0.0
+
+! LW indirect anthropogenic forcing
+     PSOLLWAIAERO(:) = 0.0 
+     PTOPLWAIAERO(:) = 0.0
+
 ENDIF
 
@@ -790,4 +919,5 @@
      PSOLSWCFAERO(:,3) = (ZFSDN_AERO(:,1,5)     -ZFSUP_AERO(:,1,5))     -(ZFSDN0_AERO(:,1,5)     -ZFSUP0_AERO(:,1,5))
      PTOPSWCFAERO(:,3) = (ZFSDN_AERO(:,KLEV+1,5)-ZFSUP_AERO(:,KLEV+1,5))-(ZFSDN0_AERO(:,KLEV+1,5)-ZFSUP0_AERO(:,KLEV+1,5))
+
 ENDIF
 
Index: /LMDZ5/trunk/libf/phylmd/rrtm/rrtm_ecrt_140gp.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/rrtm/rrtm_ecrt_140gp.F90	(revision 2145)
+++ /LMDZ5/trunk/libf/phylmd/rrtm/rrtm_ecrt_140gp.F90	(revision 2146)
@@ -10,6 +10,8 @@
  & P_ZEMIS, P_ZEMIW,&
  & pq   , pcco2, pozn, pcldf, ptaucld, ptclear,&
- & P_CLDFRAC,P_TAUCLD,P_COLDRY,P_WKL,P_WX,&
- & P_TAUAERL,PAVEL,P_TAVEL,PZ,P_TZ,P_TBOUND,K_NLAYERS,P_SEMISS,K_IREFLECT)  
+ & P_CLDFRAC,P_TAUCLD,&
+ & PTAU_LW,&
+ & P_COLDRY,P_WKL,P_WX,&
+ & P_TAUAERL,PAVEL,P_TAVEL,PZ,P_TZ,P_TBOUND,K_NLAYERS,P_SEMISS,K_IREFLECT )  
 
 !     Reformatted for F90 by JJMorcrette, ECMWF, 980714
@@ -28,15 +30,13 @@
 USE PARRRTM  , ONLY : JPBAND   ,JPXSEC   ,JPLAY   ,&
  & JPINPX  
-USE YOERAD   , ONLY : NOVLP
-!USE YOERDI   , ONLY :    RCH4     ,RN2O    ,RCFC11  ,RCFC12
+USE YOERAD   , ONLY : NLW      ,NOVLP
+USE YOERDI   , ONLY :    RCH4     ,RN2O    ,RCFC11  ,RCFC12
 USE YOESW    , ONLY : RAER
 
 !------------------------------Arguments--------------------------------
 
-
-
 IMPLICIT NONE
 
-#include "clesphys.h"
+
 INTEGER(KIND=JPIM),INTENT(IN)    :: KLON! Number of atmospheres (longitudes) 
 INTEGER(KIND=JPIM),INTENT(IN)    :: KLEV! Number of atmospheric layers 
@@ -56,4 +56,7 @@
 REAL(KIND=JPRB)   ,INTENT(IN)    :: PCLDF(KLON,KLEV) ! Cloud fraction
 REAL(KIND=JPRB)   ,INTENT(IN)    :: PTAUCLD(KLON,KLEV,JPBAND) ! Cloud optical depth
+!--C.Kleinschmitt
+REAL(KIND=JPRB)   ,INTENT(IN)    :: PTAU_LW(KLON,KLEV,NLW) ! LW Optical depth of aerosols  
+!--end
 REAL(KIND=JPRB)   ,INTENT(OUT)   :: PTCLEAR 
 REAL(KIND=JPRB)   ,INTENT(OUT)   :: P_CLDFRAC(JPLAY) ! Cloud fraction
@@ -258,4 +261,13 @@
   P_TAUAERL(I_L,16)=ZTAUAER(5)
 ENDDO
+!--Use LW AOD from own Mie calculations (C. Kleinschmitt)
+DO I_L=1,KLEV
+  JK=KLEV-I_L+1
+!  DO JAE=1, NLW 
+  DO JAE=1, 16
+    P_TAUAERL(I_L,JAE) = MAX( PTAU_LW(K_IPLON, JK, JAE), 1e-30 )
+  ENDDO
+ENDDO
+!--end C. Kleinschmitt
 
 DO J2=1,KLEV
@@ -390,6 +402,4 @@
 !     ------------------------------------------------------------------
 
-
-
 IF (LHOOK) CALL DR_HOOK('RRTM_ECRT_140GP',1,ZHOOK_HANDLE)
 END SUBROUTINE RRTM_ECRT_140GP
Index: /LMDZ5/trunk/libf/phylmd/rrtm/rrtm_ecrt_140gp.intfb.h
===================================================================
--- /LMDZ5/trunk/libf/phylmd/rrtm/rrtm_ecrt_140gp.intfb.h	(revision 2145)
+++ /LMDZ5/trunk/libf/phylmd/rrtm/rrtm_ecrt_140gp.intfb.h	(revision 2146)
@@ -1,14 +1,19 @@
-INTERFACE
-SUBROUTINE RRTM_ECRT_140GP&
+INTERFACE 
+SUBROUTINE RRTM_ECRT_140GP &
  & ( K_IPLON, klon , klev, kcld,&
  & paer , paph , pap,&
- & pts , pth , pt,&
+ & pts  , pth  , pt,&
  & P_ZEMIS, P_ZEMIW,&
- & pq , pcco2, pozn, pcldf, ptaucld, ptclear,&
- & P_CLDFRAC,P_TAUCLD,P_COLDRY,P_WKL,P_WX,&
- & P_TAUAERL,PAVEL,P_TAVEL,PZ,P_TZ,P_TBOUND,K_NLAYERS,P_SEMISS,K_IREFLECT) 
-USE PARKIND1 ,ONLY : JPIM ,JPRB
-USE PARRRTM , ONLY : JPBAND ,JPXSEC ,JPLAY ,&
- & JPINPX 
+ & pq   , pcco2, pozn, pcldf, ptaucld, ptclear,&
+ & P_CLDFRAC,P_TAUCLD,&
+ & PTAU_LW,&
+ & P_COLDRY,P_WKL,P_WX,&
+ & P_TAUAERL,PAVEL,P_TAVEL,PZ,P_TZ,P_TBOUND,K_NLAYERS,P_SEMISS,K_IREFLECT )
+USE PARKIND1  ,ONLY : JPIM     ,JPRB
+USE PARRRTM  , ONLY : JPBAND   ,JPXSEC   ,JPLAY   ,&
+ & JPINPX  
+USE YOERAD   , ONLY : NLW      ,NOVLP
+USE YOERDI   , ONLY :    RCH4     ,RN2O    ,RCFC11  ,RCFC12
+USE YOESW    , ONLY : RAER
 INTEGER(KIND=JPIM),INTENT(IN) :: KLON
 INTEGER(KIND=JPIM),INTENT(IN) :: KLEV
@@ -28,4 +33,7 @@
 REAL(KIND=JPRB) ,INTENT(IN) :: PCLDF(KLON,KLEV)
 REAL(KIND=JPRB) ,INTENT(IN) :: PTAUCLD(KLON,KLEV,JPBAND)
+!--C.Kleinschmitt
+REAL(KIND=JPRB)   ,INTENT(IN)    :: PTAU_LW(KLON,KLEV,NLW) ! LW Optical depth of aerosols  
+!--end
 REAL(KIND=JPRB) ,INTENT(OUT) :: PTCLEAR
 REAL(KIND=JPRB) ,INTENT(OUT) :: P_CLDFRAC(JPLAY)
Index: /LMDZ5/trunk/libf/phylmd/rrtm/rrtm_rrtm_140gp.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/rrtm/rrtm_rrtm_140gp.F90	(revision 2145)
+++ /LMDZ5/trunk/libf/phylmd/rrtm/rrtm_rrtm_140gp.F90	(revision 2146)
@@ -40,4 +40,5 @@
  & PQ    , PCCO2 , POZN,&
  & PCLDF , PTAUCLD,&
+ & PTAU_LW,&
  & PEMIT , PFLUX , PFLUC, PTCLEAR &
  & )  
@@ -55,5 +56,5 @@
 USE PARKIND1  ,ONLY : JPIM     ,JPRB
 USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
-
+USE YOERAD    ,ONLY : NLW
 USE PARRRTM  , ONLY : JPBAND   ,JPXSEC   ,JPGPT    ,JPLAY    ,&
  & JPINPX  
@@ -80,4 +81,7 @@
 REAL(KIND=JPRB)   ,INTENT(IN)    :: PCLDF(KLON,KLEV) ! Cloud fraction
 REAL(KIND=JPRB)   ,INTENT(IN)    :: PTAUCLD(KLON,KLEV,JPBAND) ! Cloud optical depth
+!--C.Kleinschmitt
+REAL(KIND=JPRB)   ,INTENT(IN)    :: PTAU_LW(KLON,KLEV,NLW) ! LW Optical depth of aerosols
+!--end
 REAL(KIND=JPRB)   ,INTENT(OUT)   :: PEMIT(KLON) ! Surface LW emissivity
 REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFLUX(KLON,2,KLEV+1) ! LW total sky flux (1=up, 2=down)
@@ -204,5 +208,7 @@
    & P_ZEMIS, P_ZEMIW,&
    & pq   , pcco2, pozn, pcldf, ptaucld, ztclear,&
-   & Z_CLDFRAC,Z_TAUCLD,Z_COLDRY,Z_WKL,Z_WX,&
+   & Z_CLDFRAC,Z_TAUCLD,&
+   & PTAU_LW,&
+   & Z_COLDRY,Z_WKL,Z_WX,&
    & Z_TAUAERL,Z_PAVEL,Z_TAVEL,Z_PZ,Z_TZ,Z_TBOUND,I_NLAYERS,Z_SEMISS,IREFLECT)  
 
Index: /LMDZ5/trunk/libf/phylmd/rrtm/rrtm_rrtm_140gp.intfb.h
===================================================================
--- /LMDZ5/trunk/libf/phylmd/rrtm/rrtm_rrtm_140gp.intfb.h	(revision 2145)
+++ /LMDZ5/trunk/libf/phylmd/rrtm/rrtm_rrtm_140gp.intfb.h	(revision 2146)
@@ -1,15 +1,18 @@
 INTERFACE
-SUBROUTINE RRTM_RRTM_140GP&
+SUBROUTINE RRTM_RRTM_140GP &
  & ( KIDIA , KFDIA , KLON , KLEV,&
- & PAER , PAPH , PAP,&
- & PTS , PTH , PT,&
+ & PAER  , PAPH  , PAP,&
+ & PTS   , PTH   , PT,&
  & P_ZEMIS , P_ZEMIW,&
- & PQ , PCCO2 , POZN,&
+ & PQ    , PCCO2 , POZN,&
  & PCLDF , PTAUCLD,&
- & PEMIT , PFLUX , PFLUC, PTCLEAR&
- & ) 
+ & PTAU_LW,&
+ & PEMIT , PFLUX , PFLUC, PTCLEAR )
 USE PARKIND1 ,ONLY : JPIM ,JPRB
+USE YOERAD   ,ONLY : NLW !--C.Kleinschmitt
 USE PARRRTM , ONLY : JPBAND ,JPXSEC ,JPGPT ,JPLAY ,&
- & JPINPX 
+ & JPINPX  
+!-NLW in clesphys now OB
+include "clesphys.h"
 INTEGER(KIND=JPIM),INTENT(IN) :: KLON
 INTEGER(KIND=JPIM),INTENT(IN) :: KLEV
@@ -29,4 +32,7 @@
 REAL(KIND=JPRB) ,INTENT(IN) :: PCLDF(KLON,KLEV)
 REAL(KIND=JPRB) ,INTENT(IN) :: PTAUCLD(KLON,KLEV,JPBAND)
+!--C.Kleinschmitt
+REAL(KIND=JPRB)   ,INTENT(IN)    :: PTAU_LW(KLON,KLEV,NLW) ! LW Optical depth of aerosols  
+!--end
 REAL(KIND=JPRB) ,INTENT(OUT) :: PEMIT(KLON)
 REAL(KIND=JPRB) ,INTENT(OUT) :: PFLUX(KLON,2,KLEV+1)
Index: /LMDZ5/trunk/libf/phylmd/tracinca_mod.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/tracinca_mod.F90	(revision 2145)
+++ /LMDZ5/trunk/libf/phylmd/tracinca_mod.F90	(revision 2146)
@@ -28,5 +28,5 @@
        nstep,    julien,   gmtime,         lafin,     &
        pdtphys,  t_seri,   paprs,          pplay,     &
-       pmfu,     ftsol,    pctsrf,         pphis,     &
+       pmfu,     upwd,     ftsol,  pctsrf, pphis,     &
        pphi,     albsol,   sh,             rh,        &
        cldfra,   rneb,     diafra,         cldliq,    &
@@ -88,5 +88,6 @@
 !Convection:
 !----------
-    REAL,DIMENSION(klon,klev),INTENT(IN) :: pmfu  ! flux de masse dans le panache montant
+    REAL,DIMENSION(klon,klev),INTENT(IN) :: pmfu  ! flux de masse dans le panache montant - Tiedtke
+    REAL,DIMENSION(klon,klev),INTENT(IN) :: upwd  ! flux de masse dans le panache montant - Emanuel
 
 !...Tiedke     
@@ -120,4 +121,5 @@
     INTEGER :: k
     REAL,DIMENSION(klon,klev) :: pdel
+    REAL,DIMENSION(klon,klev) :: zpmfu  ! flux de masse dans le panache montant
     REAL    :: calday
     INTEGER :: ncsec
@@ -133,4 +135,6 @@
     END DO
     
+    zpmfu(:,:)=pmfu(:,:)
+
     IF (config_inca == 'aero') THEN
 #ifdef INCA
@@ -138,5 +142,5 @@
             aerosol_couple,tr_seri,pdtphys, &
             pplay,pdel,prfl,pmflxr,psfl,    &
-            pmflxs,pmfu,itop_con,ibas_con,  &
+            pmflxs,zpmfu,itop_con,ibas_con,  &
             pphi,airephy,nstep,rneb,t_seri, &      
             rh,tau_aero,piz_aero,cg_aero,   &
@@ -144,4 +148,17 @@
 #endif
     END IF
+
+    IF (config_inca == 'aeNP') THEN
+#ifdef INCA
+       zpmfu(:,:)=upwd(:,:)
+       CALL aerosolmainNP(                  &
+            aerosol_couple,tr_seri,pdtphys, &
+            pplay,pdel,prfl,pmflxr,psfl,    &
+            pmflxs,zpmfu,itop_con,ibas_con,  &
+            pphi,airephy,nstep,rneb,t_seri, &      
+            rh,lafin)
+#endif
+    END IF
+
 
 #ifdef INCA
@@ -172,5 +189,5 @@
          psfl,       & !flxsst
          pmflxs,     & !flxscv
-         pmfu,       & !flxupd
+         zpmfu,      & !flxupd   !--now depends on whether AP or NP
          flxmass_w,  & !flxmass_w
          t_seri,     & !tfld
